//----------------------------------------------------------------
/* TEN
/*  Programmed by M.I Jul-20/1990
/* Oh!X 1990-10,1991-3
/*	フロー/動作のおかしな部分を大幅書き換え AIG-Soft 2013
// V3.20以降専用
//----------------------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
	KEY_CHECK='C'
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
//width(0)
//tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
//vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

//----------------------------------------------------------------

enum
	SUMERU	=15
	SEND	=20
	SNONE	=30
	MES_SX	=160
	MES_EX	=320
	MES_SY	=2
	MES_EY	=143
	MES_SX2	=2
	MES_EX2	=336
endenum

int flag=0
dim int cc(51),ba(12),te(38),m(2)
dim int snd(8)
int i

// 音声バッファー確保
for i=1 to 8
//	locate(0,31+i):print "ten"+str$(i)+".mp3";
	snd(i)=a_setPlayData("ten"+str$(i)+".mp3")
//	print "/snd=";snd(i)
next

setgPalet16X68(1,&h000000ff)
/* main program
while flag=0
	scrn()
	prep()
	play()
	judge()
endwhile
owari()

// 音声バッファー開放
for i=1 to 8
	a_end(snd(i))
next

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()
end

//----------------------------------------------------------------

func scrn()
	int i
	vpageX68(0)
	apage(GPAGE1):wipe():/*fill16X68(0,0,511,511,0)
	apage(GPAGE2):wipe():/*fill16X68(0,0,511,511,0)
	fill16X68(0,  0,511,144,10):/* タイトル枠
	fill16X68(0,145,511,511, 8):/* 場の枠
	 box16X68(0,  0,511,511,15):/* 外枠
	 box16X68(1,  1,510,510,15):/* 外枠の内側
	line16X68(2  ,144,509,144,15):/* 上横線
	/* ↓この間がメッセージ領域になる
	
	line16X68(MES_SX+6,MES_SY,MES_SX,MES_EY,15):/* 上斜め線(左側)
	line16X68(MES_EX,  MES_SY,MES_EX,MES_EY,15):/* 上縦線(右側)
	/* ↑
	line16X68(MES_EX2,144,MES_EX2,509,15):/* 下縦線
	line16X68(    337,328,    509,328,15):/* 下横線
	if isLocalizeJapan() then {
		symbol16X68(40,24,"一人占い",1,15,FONT,FNTSZ)
	} else {
		symbol16X68(19,24,"Fortune-telling",1,15,FONT,FNTSZ)
	}
	symbol16X68(10,58,"ＴＥＮ"  ,3, 1,FONT,FNTSZ)
	symbol16X68( 8,56,"ＴＥＮ"  ,3,15,FONT,FNTSZ)
	symbol16X68(408,160,localizedString("手　札","Deal"   ),1,15,FONT,FNTSZ)
	symbol16X68(408,344,localizedString("捨て札","Discard"),1,15,FONT,FNTSZ)
	vpageX68(6)
endfunc

//----------------------------------------------------------------

func prep()
	int i,j,a,b,k
	/* dea1
	randomize(val(mid$(time$,4,2)+right$(time$,2)))
	for i=0 to 51:cc(i)=i+1:next
	m(0)=13:m(1)=39:m(2)=0
	for i=0 to 99
		a=int(rnd()*52):b=int(rnd()*52)
		k=cc(a):cc(a)=cc(b):cc(b)=k
	next
	for i=0  to 12:ba(i   )=cc(i):next
	for i=13 to 51:te(i-13)=cc(i):next
	for i=0  to 51:cc(i)=0:next
	apage(GPAGE1)
	bacd():tecd()
	circle16X68b(296,440,16,4):paint16X68b(296,432,6)
	circle16X68b( 40,440,16,4):paint16X68b( 40,432,4)
	if isLocalizeJapan() then {
		symbol16X68(288,432,"埋",1,15,FONT,FNTSZ)
		symbol16X68( 33,432,"終",1,15,FONT,FNTSZ)
	} else {
		symbol16X68(280,432,"Fill",1,15,FONT,FNTSZ)
		symbol16X68( 29,432,"End" ,1,15,FONT,FNTSZ)
	}
endfunc

//----------------------------------------------------------------

func play()
int ss,q,g=0
	while g=0
		if m(0)+m(1)>0 then q=select() else q=SEND
		switch q
			case SNONE:break
			case SEND:ss=fin():break
			case SUMERU:ref():break
			default:norm(q)
		endswitch
		if ss=1 then g=1
	endwhile
endfunc

//----------------------------------------------------------------

func norm(a;int)
int b,c,d
int a1,b1,c1,d1,a2,b2,c2,d2
	a1=(ba(a)-1) mod MAX_TRUMP:/* 数字-1    =0～12
	a2=(ba(a)-1) \   MAX_TRUMP:/* スート番号=0～3
//	locate(0,31):print "位置=";a;"/スート=";a2;"/カード=";a1+1
	if a1<9 then {
		/* 10以外の数字札である(a1=0～8:数字=1～9)
//		locate(0,32):print "数字札(1～9)"
		/* 次の1枚は数字でなければならない
		b=select()
		/* 1枚目と同じ位置はだめ
		if a<>b and b<MAX_TRUMP then {
			b1=(ba(b)-1) mod MAX_TRUMP
			if a1+b1=8 then {
				dasu(a):a_play(snd(4))
				dasu(b):a_play(snd(5))
				return()
			}
		}
		kesu(a):kesu(b)
		dame()
		return()
	}
	/* a1=9～:数字=10～
	/* 同じスートの10,J,Q,Kを4枚同時消去
	message2(160,"同じスートの10,J,Q,K指定",15)
	/* 2枚目
	b=select()
	if a<>b and b<MAX_TRUMP then {
		b1=(ba(b)-1) mod MAX_TRUMP
		b2=(ba(b)-1) \   MAX_TRUMP
		if b1>8 and b2=a2 then { /* 10以上でスートが同じ
			/* 3枚目
			c=select()
			if c<>b and c<MAX_TRUMP then {
				c1=(ba(c)-1) mod MAX_TRUMP
				c2=(ba(c)-1) \   MAX_TRUMP
				if c1>8 and c2=a2 then { /* 10以上でスートが同じ
					/* 4枚目
					d=select()
					if d<>c and d<MAX_TRUMP then {
						d1=(ba(d)-1) mod MAX_TRUMP
						d2=(ba(d)-1) \   MAX_TRUMP
						if d1>8 and d2=a2 then { /* 10以上でスートが同じ
							dasu(a):a_play(snd(4))
							dasu(b):a_play(snd(5))
							dasu(c):a_play(snd(6))
							dasu(d):a_play(snd(7))
							fill16X68(MES_SX2,160,MES_EX2,176,0)
							return()
						}
					}
					kesu(d)
				}
			}
			kesu(c)
		}
	}
	kesu(b)
	kesu(a)
	dame()
	fill16X68(MES_SX2,160,MES_EX2,176,0)
endfunc

//----------------------------------------------------------------

func int fin()
int i,j,e,k=0,m1=0,m2=0,m3=0,m4=0,n=0
	if m(0)<12 and m(1)>0 then e=0:mada():return(e)
	for i=0 to 11
		for j=i+1 to 12
			if ba(i)=0 or ba(j)=0 then continue
			if (ba(i)-1) mod MAX_TRUMP+(ba(j)-1) mod MAX_TRUMP=8 then k=1
		next
	next
	for i=0 to 12
		if ba(i)>=10 and ba(i)<=13 then m1=m1+1
		if ba(i)>=23 and ba(i)<=26 then m2=m2+1
		if ba(i)>=36 and ba(i)<=39 then m3=m3+1
		if ba(i)>=49 and ba(i)<=52 then m4=m4+1
	next
	if m1=4 or m2=4 or m3=4 or m4=4 then n=1
	if k+n>=1 then e=0:mada():return(e)
	if k+n=0  then e=1:return(e)
	/* 念のため
	return(0)
endfunc

//----------------------------------------------------------------

func ref()
	if m(0)<12 and m(1)>0 then umeru()
endfunc

//----------------------------------------------------------------

func judge()
int x,y,ten
	fill16X68(321,2,509,143,12)
	ten=m(0)+m(1):a_play(snd(8))
	if ten=0 then {
		if isLocalizeJapan() then {
			symbol16X68(325,48,"おめでとう！",2,15,FONT,FNTSZ)
		} else {
			symbol16X68(325,48,"Congratulations!",1.5,15,FONT,FNTSZ)
		}
	} else {
		symbol16X68(344,48,localizedString(str$(ten)+"枚　残りました","Left "+str$(ten)+" card(s)"),1,15,FONT,FNTSZ)
	}
	symbol16X68(336,96,localizedString("もう一度？","Try again?"),1,15,FONT,FNTSZ)
	fill16X68(432,96,463,112,15):symbol16X68(444,96,"Y",1,1,FONT,FNTSZ)
	fill16X68(465,96,496,112,15):symbol16X68(476,96,"N",1,1,FONT,FNTSZ)

	// 前のタップが残っていたら、一旦離すまで待つ
	while getTouchStatus()<>TOUCH_NONE
	endwhile

	// タッチされるまで待つ
	repeat:until getTouchStatus()<>TOUCH_NONE

	dim float tpoint(1)
	int touchCnt=getTouchPoint(tpoint)
	x=tpoint(0)
	y=tpoint(1)

	if x>465 then flag=1
endfunc

//----------------------------------------------------------------

func owari()
	vpageX68(2):apage(GPAGE1)
	fill16X68(0,0,511,511,2)
	symbol16X68(272,400,localizedString("お疲れ様でした","Many thanks."),2,15,FONT,FNTSZ)
endfunc

//----------------------------------------------------------------

func int select()
int i=SNONE:/* 無効な選択の印
int x,y
	if isLocalizeJapan() then {
		message(48,"出したいカードを",15)
		message(80,"タップ",15)
	} else {
		message(48,"Tap the card that",15)
		message(80," you want to give",15)
	}

	// 前のタップが残っていたら、一旦離すまで待つ
	while getTouchStatus()<>TOUCH_NONE
	endwhile

	// タッチされるまで待つ
	repeat:until getTouchStatus()<>TOUCH_NONE

	dim float tpoint(1)
	int touchCnt=getTouchPoint(tpoint)
	x=tpoint(0)
	y=tpoint(1)

	erupms()
	int xx,yy
	xx=(x-16)\64:yy=(y-183)\104:i=yy*5+xx
	if i=14 then i=SUMERU:/* 埋める
	if i=10 then i=SEND:/* 終わり
	xx=xx*64+15:yy=yy*104+183
	if i<15 then box16X68(xx,yy,xx+48,yy+97,5)
	if i>9 and i<14 then i=i-1
	return(i)
endfunc

//----------------------------------------------------------------

func kesu(c;int)
int x,y
	if c<10 then x=(c mod 5)*64+15 else x=(c mod 5)*64+79
	y=(c \ 5)*104+183
	box16X68(x,y,x+CARD_WX,y+CARD_WY+1,0)
	box16X68(x-1,y-1,x+CARD_WX+1,y+CARD_WY+1+1,0):/* iOSでは一回り消す
//locate(0,32):print "kesu(";x;",";y;")"
endfunc

//----------------------------------------------------------------

func dasu(c;int)
int x,y,s,t
	if c<10 then x=(c mod 5)*64+15 else x=(c mod 5)*64+79
	y=(c \ 5)*104+183
//	fill16X68(x,y,x+50,y+98,0)
	fill16X68(x-1,y-1,x+50+1,y+98+1,0):/* 一回り大きく消す(iOSではそうしないと描画が残ってしまう)
	m(0)=m(0)-1:if m(0)<0 then m(0)=0
	m(2)=m(2)+1
	s=int(rnd()*96)+352
	t=int(rnd()*24)+376
	cardPut(s,t,ba(c),NO)
	box16X68(s-1,t-1,s+47,t+96,8)
	ba(c)=0:cwait(10)
endfunc

//----------------------------------------------------------------

func umeru()
int i,x,y
	for i=0 to 12
	if ba(i)=0 then {
		if i<10 then x=(i mod 5)*64+16 else x=(i mod 5)*64+80
		y=(i \ 5)*104+184
		if m(1)=0 then fill16X68(360,182,408,288,0):break
		cardPut(x,y,te(m(1)-1),NO):a_play(snd(3))
		ba(i)=te(m(1)-1)
		fill16X68(m(1)*2+360,182,m(1)*2+408,288,0)
		cardPut(m(1)*2+358,192,0,NO)
		m(0)=m(0)+1
		m(1)=m(1)-1:if m(1)<0 then m(1)=0
	}
	next
	fill16X68(416,304,432,320,0)
	symbol16X68(416,304,str$(m(1)),1,15,FONT,FNTSZ)
endfunc

//----------------------------------------------------------------

func bacd()
/* 場card
int i
	for i=0 to 4
		cardPut(i*64+16,184,ba(i   ),NO):a_play(snd(1))
		cardPut(i*64+16,288,ba(i+5 ),NO):a_play(snd(1))
	next
	for i=0 to 2
		cardPut(i*64+80,392,ba(i+10),NO):a_play(snd(1))
	next
endfunc

//----------------------------------------------------------------

func tecd()
int i
	for i=0 to m(1)-1
		cardPut(i*2+362,192,0,NO)
		line16X68(i*2+362,192,i*2+362,288,8)
		a_play(snd(1))
	next
	fill16X68(416,304,432,320,0)
	symbol16X68(416,304,str$(m(1)),1,15,FONT,FNTSZ)
endfunc

//----------------------------------------------------------------

func dame()
	message(48,localizedString("出せません","Don't give"),5)
	a_play(snd(2)):cwait(80):erupms()
endfunc

//----------------------------------------------------------------

func mada()
	message(48,localizedString("終わってません","Not over"),5)
	a_play(snd(2)):cwait(50):erupms()
endfunc

//----------------------------------------------------------------

func message(sy;int,mes;str,col;int)
	int sx=((MES_EX-MES_SX)-utf8StrWidth(mes)*(FNTSZ/2))/2
	symbol16X68(sx+MES_SX,sy,mes,1,col,FONT,FNTSZ)
endfunc
/*
func message2(sy;int,mes;str,col;int)
	int sx=((MES_EX2-MES_SX2)-utf8StrWidth(mes)*(FNTSZ/2))/2
	symbol16X68(sx+MES_SX2,sy,mes,1,col,FONT,FNTSZ)
endfunc

func erupms()
/* メッセージ領域のクリア
	fill16X68(161,3,319,143,0)
endfunc

//----------------------------------------------------------------

func cwait(t;int)
/* 時間待ち
	wait((47.0/500.0/5.0)*t)
endfunc

//****************************************************************
